/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ROTFABRICA                                               */
/* Tabela : ROTFABRICA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_ROTFABRICA'  and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
DROP TRIGGER DTULTATU_ROTFABRICA
GO

CREATE TRIGGER DTULTATU_ROTFABRICA
ON ROTFABRICA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ROTFABRICA', 'CDPRODUTO=' + CDPRODUTO +
                                     ';CDSUBPRODUTO='+ CDSUBPRODUTO+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ROTFABRICA
      SET DTULTATURTFA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ROTFABRICA.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(ROTFABRICA.CDSUBPRODUTO,0) = ISNULL(INSERTED.CDSUBPRODUTO,0));
   END;
END;
GO

UPDATE ROTFABRICA SET DTULTATURTFA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATURTFA IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATURTFA' and
            type = 'D')
   ALTER TABLE ROTFABRICA DROP CONSTRAINT DEFAULT_DTULTATURTFA
GO

ALTER TABLE ROTFABRICA ADD CONSTRAINT DEFAULT_DTULTATURTFA
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATURTFA
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ROTFABRICA','4.11.194';
GO

